; GUI #
include win64a.inc
IDB_MYBITMAP	= 105
IDC_DIALOG	= 200
HIMETRIC_PER_INCH = 2540
IMG_X		= 932*2/3;960
IMG_Y		= 1341*2/3;540
ID_IMG		equ 100
.code
WinMain proc
local	msg:MSG

	xor	ebx,ebx
	mov	esi,IMAGE_BASE
	mov	ecx,offset FileName
	invoke	LoadCursorFromFileA
	mov	edi,offset ClassName
	push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOW+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc      ;lpfnWndProc
	push	sizeof WNDCLASSEX;cbSize & style
	invoke	RegisterClassExA,esp	;addr WNDCLASSEX	
	push	rbx	;lParam
	push	rsi	;hinstance=rsi=400000h
	shl	esi,9	;rsi=CW_USEDEFAULT
	push	rbx        ;hMenu
	push	rbx        ;hWmdParent
	push	IMG_Y+20   ;nHeight
	push	IMG_X+10   ;nWidth
	push	rsi        ;y
	push	rsi        ;x
	sub	esp,20h
    	invoke	CreateWindowExA,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_VISIBLE
    	lea	edi,msg
@@:     invoke	GetMessageA,edi,0,0,0
	invoke	DispatchMessageA,edi
	jmp	@b
WinMain endp
;---------------------------------------------------------------
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
local	hImgBox:qword
local	hResource:qword
local	pResource:qword
local	FSize:dword
local	rct:RECT

        mov	hWnd,rcx

        cmp	edx,WM_CREATE
	je	wmCREATE
        cmp	edx,WM_DESTROY
	je	wmDESTROY
wmDEFAULT:leave
      	jmp	NtdllDefWindowProc_
wmDESTROY:invoke RtlExitUserProcess,NULL
wmCREATE:mov	edx,offset aStatic
	invoke	CreateWindowExA,WS_EX_LEFT,,0,WS_CHILD or WS_VISIBLE \
	or SS_BITMAP,0,0,0,0,hWnd,ID_IMG,IMAGE_BASE,0
	mov	hImgBox,rax
;  OLE
        invoke  OleInitialize,NULL
;--------------------------------------------------------------
;    
        invoke  FindResource,0,IDB_MYBITMAP,RT_RCDATA
        mov     hResource,rax
        invoke  SizeofResource,NULL,eax
        mov     FSize,eax
        invoke  LoadResource,NULL,hResource
        mov     pResource,rax
;    
        invoke  GetProcessHeap
        mov     hProcHeap,rax
        invoke  RtlAllocateHeap,eax,HEAP_ZERO_MEMORY,FSize
        mov     hLock,rax
;     
        invoke  LockResource,pResource
        mov     esi,eax
        mov     rdi,hLock
        mov     ecx,FSize
        rep     movsb
;    
	mov	r8d,offset iStream
        invoke  CreateStreamOnHGlobal,hLock,TRUE
;    
	movr	qword ptr[rsp+20h],iPicture
	mov	r9d,offset IID_IPicture
        invoke  OleLoadPicture,iStream,0,TRUE
;    IPicture->get_Handle()
        mov     rcx,iPicture
        mov     eax,[rcx]
	mov	edx,offset hBitmap
        call	qword ptr[rax].IPicture.get_Handle
;    IPicture->get_Width()
        mov     rcx,iPicture
        mov     eax,[rcx]
	mov	edx,offset bm.bmWidth
        call	qword ptr[rax].IPicture.get_Width
;       
        invoke  GetDC,NULL
        invoke  GetDeviceCaps,eax,LOGPIXELSX
;  HIMETRIC   
        imul    bm.bmWidth
        xor	edx,edx
        mov     ecx,HIMETRIC_PER_INCH
        idiv    ecx
;  
        mov     bm.bmWidth,eax
;    IPicture->get_Height()
        mov     rcx,iPicture
        mov     eax,[rcx]
	mov	edx,offset bm.bmHeight
        call	qword ptr[rax].IPicture.get_Height
;       
        invoke  GetDC,NULL
        invoke  GetDeviceCaps,eax,LOGPIXELSY
        ;  HIMETRIC   
        imul    bm.bmHeight
	xor	edx,edx
        mov     ecx,HIMETRIC_PER_INCH
        idiv    ecx
;  
        mov	bm.bmHeight,eax
;     
        invoke  GetDC,NULL
        invoke  CreateCompatibleBitmap,eax,IMG_X,IMG_Y
        mov     imgBitmap,rax
        invoke  CreateCompatibleDC,NULL
        mov     hDC1,rax
        invoke  SelectObject,eax,imgBitmap
        mov     hOld1,rax

        invoke  CreateCompatibleDC,NULL
        mov     hDC2,rax
        invoke  SelectObject,eax,hBitmap
        mov     hOld2,rax
;   
        mov     rct.bottom,IMG_Y
        mov     rct.right,IMG_X
        and	qword ptr rct.top,0;top & left
;    
        invoke  GetSysColorBrush,COLOR_BTNFACE
	lea	edx,rct
        invoke  FillRect,hDC1,,eax
;      
        invoke  SetStretchBltMode,hDC1,HALFTONE
	mov	eax,bm.bmHeight
	mov	[rsp+48h],rax
	mov	eax,bm.bmWidth
	mov	[rsp+40h],rax
        invoke  StretchBlt,hDC1,0,0,IMG_X,IMG_Y,\
	hDC2,0,0,,,SRCCOPY
        invoke  SelectObject,hDC1,hOld1
        invoke  DeleteDC,hDC1
        invoke  SelectObject,hDC2,hOld2
        invoke  DeleteDC,hDC2
;     static
        invoke  SendMessageA,hImgBox,STM_SETIMAGE,IMAGE_BITMAP,imgBitmap
;    IPicture->Release()
        mov     rcx,iPicture
        mov     eax,[rcx]
        call	qword ptr[rax].IPicture.Release
;  
        invoke  HeapFree,hProcHeap,0,hLock
        invoke  OleUninitialize
wmBYE:  mov	eax,TRUE
	leave
        retn
WndProc endp
.data;---------------------------------------
align 10h
bm		BITMAP <>
hBitmap         dq ?
imgBitmap       dq ?
hDC1            dq ?
hDC2            dq ?
hOld1           dq ?
hOld2           dq ?
iStream		dq ?
hProcHeap	dq ?
hLock		dq ?
iPicture	dq ?
; GUID {7BF80980-BF32-101A-8BBB-00AA00300CAB}
IID_IPicture	GUID <7BF80980h,0BF32h,101Ah,{8Bh,0BBh,0,0AAh,0,30h,0Ch,0ABh}>
aStatic		db "STATIC",0
ClassName	db "OLE",0
FileName	db "br_Rabbit3.cur",0
end